if (window.widget)
{
    widget.onshow = onshow;
    widget.onhide = onhide;
}

var connectedToPower = false;
var charging = false;
var batteryPromilage = 0;
var minutesToCapacity = 0;
var minutesToZero = 0;
var capacityMinutes = 0;
var timer = null;
var hasMs = false;
var hasBattery = false;
var hasCheckedOnce = false;
var shown = false;
var MaxCapacity ='';
var cycles = '';

function onshow(){
	shown=true;
	if (timer==null)
	{
		timer = setInterval ("readOutBattery();", 10000);
	}
	updateInterface();
	readOutBattery();

    if (window.devicePixelRatio && window.devicePixelRatio>1)
    {
        var bg = document.getElementById("backgroundImage");
        var fg = document.getElementById("img");
        bg.src='Images/Battery%20back@2x.png';
        fg.src='Default@2x.png';
    }
}


function onhide(){
	shown=false;
	if (timer!=null)
	{
		clearInterval(timer);
		timer=null;
	}
}


function updateInterface(){
	if (shown && hasCheckedOnce){
		var percentage = document.getElementById("percentage");
		var batterystatus = document.getElementById("batterystatus");
		var calculation = document.getElementById("calculation");
		var meter = document.getElementById("meter");
		var capacity = document.getElementById("capacity");
		var cyclesspan = document.getElementById("cyclesspan");
		if (!hasBattery){
			batterystatus.innerText = getLocalizedString('No Battery...');
			percentage.innerText = '- %';
			calculation.innerText = getLocalizedString('No Battery Found');
			capacity.innerText = '-';
			batteryduration.innerText = '-';
			return;
		}
		capacity.innerText=MaxCapacity+' mAh';
		cyclesspan.innerText = ''+cycles+getLocalizedString(' cycles');
		if (batteryPromilage==0) percentage.innerText='0%';
		else if (batteryPromilage==1000) percentage.innerText='100%';
		else percentage.innerText=Math.floor(batteryPromilage/10)+"."+(batteryPromilage%10)+"%";
		
		if (batteryPromilage>900){
			meter.src='Images/100.png';
		}else if (batteryPromilage>800){
			meter.src='Images/90.png';
		}else if (batteryPromilage>700){
			meter.src='Images/80.png';
		}else if (batteryPromilage>600){
			meter.src='Images/70.png';
		}else if (batteryPromilage>500){
			meter.src='Images/60.png';
		}else if (batteryPromilage>400){
			meter.src='Images/50.png';
		}else if (batteryPromilage>300){
			meter.src='Images/40.png';
		}else if (batteryPromilage>200){
			meter.src='Images/30.png';
		}else if (batteryPromilage>100){
			meter.src='Images/20.png';
		}else if (batteryPromilage>50){
			meter.src='Images/10.png';
		}else{
			meter.src='Images/5.png';
		}
		if (connectedToPower){
			if (charging){
				batterystatus.innerText=getLocalizedString('Charging...');
				if (hasMs){
					calculation.innerText= getTime(minutesToCapacity)+ getLocalizedString(' until full');
				}else{
					calculation.innerText=getLocalizedString('Calculating...');
				}
			}
			else{
				if (batteryPromilage>900){
					batterystatus.innerText=getLocalizedString('Charged...');
					calculation.innerText=getLocalizedString('Battery is full');
				}else if (batteryPromilage<100){
					batterystatus.innerText=getLocalizedString('Waiting...');
					calculation.innerText=getLocalizedString('Battery is empty');
				}else{
					batterystatus.innerText=getLocalizedString('Connected...');
					calculation.innerText=getLocalizedString('Calculating...');
				}
			}
		}else{
			batterystatus.innerText=getLocalizedString('On Battery...');
			if (hasMs){
				calculation.innerText= getTime(minutesToZero)+ getLocalizedString(' remaining');
			}else{
				calculation.innerText=getLocalizedString('Calculating...');
			}
		}
	}
}

function getTime(input){
	var hours = Math.floor(input/60);
	var minutes = Math.floor(input) % 60;
	var output = ''+hours+':'+(minutes>9?''+minutes:'0'+minutes);
	return output;
}


function trim(str)
{
   return str.replace(/^\s*|\s*$/g,"");
}

function afterEqual(str)
{
	var output = str.substr(str.indexOf('=')+2);
	return trim(output);
}

function getHexValue(input)
{
	if (input.length>10){	//cut of the head of 64 bit int, keep 16 bit
		input = input.substr(input.length-4);
		input='0x'+input;
	}
	input = parseInt(input);
	if (input>32767){
		input = 65536 - input;
		input = -1 * input;
	}
	return input;
}

function readOutBattery()
{
	hasCheckedOnce = true;
	//PowerBook iBook support
	var outputPPC = widget.system("/usr/sbin/ioreg -p IODeviceTree -n \"battery\" -w 0 -x| grep IOBatteryInfo", null).outputString;
	//outputPPC = '"LegacyBatteryInfo" = {"Capacity"=0x13b9,"Amperage"=0xfffffffffffff7a3,"Cycle Count"=0x2d,"Current"=0x48a,"Voltage"=0x2ac5,"Flags"=0x4}';

	if (outputPPC && outputPPC.length>10){
		hasBattery = true;
		outputPPC = outputPPC.substring(outputPPC.indexOf("{")+1, outputPPC.indexOf("}"));
		
		//var MaxCapacity;
		var CurrentCapacity;
		var Amperage;
		var IsCharging;
		var ExternalConnected;
		
		var voltage;
		while (outputPPC.length>1){
			var c = outputPPC.indexOf(",");
			var pc = '';
			if (c>-1){
				pc = outputPPC.substring(0, outputPPC.indexOf(","));
				outputPPC = outputPPC.substring(outputPPC.indexOf(",")+1);
			}else{
				pc = outputPPC;
				outputPPC = '';
			}
			var name = pc.substring(1, pc.indexOf("=")-1);
			var value = pc.substring(pc.indexOf("=")+1);
			if (name == 'Capacity') MaxCapacity = getHexValue(value);
			if (name == 'Current') CurrentCapacity = getHexValue(value);
			if (name == 'Amperage') Amperage = getHexValue(value);
			if (name == 'Voltage') voltage = getHexValue(value);
			if (name == 'Flags') flags = getHexValue(value);
			if (name == 'Cycle Count') cycles = getHexValue(value);
		}
		connectedToPower = flags!=4 && flags!=20 && flags!=148;
		charging=Amperage>0 && connectedToPower;
		batteryPromilage = Math.floor((CurrentCapacity*1000) / MaxCapacity);
		hasMs=false;
		
		if (Amperage>5 || Amperage<-5){
			minutesToCapacity = 60*(MaxCapacity - CurrentCapacity)/Amperage;
			minutesToZero = -(60 * CurrentCapacity) / Amperage;
			if (charging && minutesToCapacity>=0) hasMs=true;
			if (!charging && minutesToZero>=0) hasMs=true;
		}
		updateInterface();
		return;
	}
	
	//MacBook support
	var output = widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 -x | grep "\\"BatteryInstalled\\" ="', null).outputString;
	if (output && afterEqual(output)=='Yes'){
		hasBattery = true;
	}else{
		hasBattery = false;
	}
	if (hasBattery){
		MaxCapacity = getHexValue(afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 -x | grep "\\"MaxCapacity\\" ="', null).outputString));
		cycles = getHexValue(afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 -x | grep "\\"CycleCount\\" ="', null).outputString));
		var CurrentCapacity = getHexValue(afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 -x| grep "\\"CurrentCapacity\\" ="', null).outputString));
		var Amperage = getHexValue(afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 -x| grep "\\"Amperage\\" ="', null).outputString));
		batteryPromilage = Math.floor((CurrentCapacity*1000) / MaxCapacity);
		var IsCharging = afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 | grep "\\"IsCharging\\" ="', null).outputString);
		charging = IsCharging == 'Yes';
		var ExternalConnected = afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 | grep "\\"ExternalConnected\\" ="', null).outputString);
		connectedToPower = ExternalConnected == 'Yes';
		var TimeRemaining = getHexValue(afterEqual(widget.system('/usr/sbin/ioreg -n AppleSmartBattery -w0 -x| grep "\\"TimeRemaining\\" ="', null).outputString));
		hasMs=false;
		if (Amperage>5 || Amperage<-5){
			minutesToCapacity = 60*(MaxCapacity - CurrentCapacity)/Amperage;
			//minutesToZero = TimeRemaining;
			minutesToZero = -(60 * CurrentCapacity) / Amperage;
			if (charging && minutesToCapacity>=0) hasMs=true;
			if (!charging && minutesToZero>=0) hasMs=true;
		}
	}
	
	updateInterface();
}

function getLocalizedString (key)
{
	try {
		return localizedStrings[key];
	} catch (ex) {}

	return key;
}
